\section{Improvements}
An idea that has come to our minds is improvement of the futuristic
function for the jewel problem. The Manhattan distance is great for
achieving a lose result, but if we have to pass through a wall on our
way to the goal position, the heuristic would be misleading and
possibly just send the algorithm straight towards the wall. Now since
the heuristics in our situation is only reflecting static properties,
the heuristics in a specific position will always be the
same. Therefore a matrix could be build that would reflect the
heuristics.

Such a matrix is only build once, and therefore a more
sophisticated search could be applied for each cell position in the
matrix - a suggestion could be a Dijkstra algorithm which saves the
shortest possible distance to a goal in each cell, or our own
man problem solution, which does exactly the same. The result would be
a kind of potential-field that draws jewel-search in a more realistic
direction each time.

Another place where precalculation could be used to improve the search
is in the case of a man problem. If we in the jewel-problem look at
the \verb!successor()! we find that the man in each node step is being
sent at most $n\cdot 4-1$ times of from the same position out to other
positions. Each time the man has to be moved in this way, a new man
problem is being initiated and tested. If we apply a single search
(maybe Dijkstra again) and saves the steps for each position reached,
we would instead be able to reuse the resulting matrix grid as it also
includes a path to the jewel positions it can reach.

In the specific case of the C\# planner, no priority queues were used
at checking the repeated states of the problems. If we use a kind of ordered list
we could improve the speed of searching for repeated states, by calling 
binary search methods.

\section{Conclusions}

We have now implemented two planners where we showed that it was
possible to solve a Sokoban puzzle by using state-space problem
formulation together with informed algorithms. 

At the demonstration we showed that our agent was able to execute our
plan and move a set of bricks around in a grid that represented the
Sokoban puzzle.  We had in the process faced a serious of problems
(malformed search, commented code, and twisted wires) but was able to
solve the problems.

The result of the project has given us insight in game-planning using
these techniques, and specially about the simplified abstractions of
the real world problem; which is useful not just here, but in many
fields with modeling involved.

The comparison of the planners' execution time, shows us one more time
that different programming languages are to be used in different
tasks. The C\# planner was very useful to test different searching
algorithms, to get insight about what we were studying, and to test
the abstractions made from the problem. Nevertheless, at the moment of
getting optimal solutions on short times, C++ comes to the scenario;
showing us the speed that make him the preferred language at building
fast execution programs.
